# sake-js

[![NPM Version][npm-image]][npm-url]
[![NPM Downloads][downloads-image]][downloads-url]
[![NPM any][size-image]][size-url]

[npm-image]: https://img.shields.io/npm/v/sake-js.svg
[npm-url]: https://npmjs.org/package/sake-js
[downloads-image]: https://img.shields.io/npm/dm/sake-js.svg
[downloads-url]: https://npmjs.org/package/sake-js
[size-image]: https://packagephobia.com/badge?p=sake-js
[size-url]: https://packagephobia.com/result?p=sake-js

JavaScript encryption <br>
garbage string code in dizzying javascript

### [demo](https://nuojs.github.io/sake-js/demo.html)

## install

```
npm install sake-js
```

browser

```html
<script src="https://cdn.jsdelivr.net/npm/sake-js@1.1.5/browser/index.min.js"></script>
```

usage

```js
// window.SakeJS -> browser
let SakeJS = require("sake-js");
let text = `
function main(t){
    console.log(t)
}
main("hello world!!") 
`;
let res = SakeJS.obfuscate(text);
console.log(res);
// [ゟ,ィ,ア,ね,が,,ㄮ,ヴ,ゞ,ゾ,,,,コ,,ょ]="."+{},グ=[],[,ゐ,フ,ゅ,ベ,ザ,ㄏ,ぷ,,,ダ,ネ,,,ヌ]=[!!ㄮ]+!ㄮ+ㄮ.ㄮ,[,,,,,,,,,ー,,,,,そ]=ゟ[コ+=ア+ダ+ぷ+ヴ+ゐ+フ+ㄮ+ヴ+ア+ゐ]+グ,[,,,,,,,,カ,,,,,ゎ,ヅ,,ㄞ,,,,,,,ウ,,,,,,,,,て]=[][ベ+ヌ+ㄏ+ㄏ]+グ,ゖ=[ヴ+ア+ー+ヴ+ゐ+ヌ+ダ+そ],[オ,,ま,,を,,ぱ,,わ,,ゆ,,゛,,し,,エ,,や]=[+カ,++カ,++カ,++カ,++カ,++カ,++カ,++カ,++カ,++カ]+グ,ず=グ[コ][コ],ㄦ=ず(ゅ,ゐ+ゅ+ヴ+フ+ゐ+ダ+ゞ+ゅ+ゟ+ヴ+ア+ー+ヴ+ゐ+ヌ+ダ+そ+ゎ+ぱ+゛+ヅ),[ㄆ,ㄍ,タ,と,い]=[ㄦ(+[を+ゆ]),ㄦ(+[ま+し]),ㄦ(+[を+を]),ㄦ(+[を+オ]),ㄦ(+[ぱ+わ])],[こ,,ぐ,,,,え,,,,す]=ず(ゐ+ゅ+ヴ+フ+ゐ+ダ+ゞ+ゅ+ぷ+ㄮ+ザ+ㄆ+ゅ)()((グ+グ)[ヌ+ヴ+ザ+ㄏ+ヌ+ㄮ+ぷ]()),ぽ=ず(ゅ,ゐ+ゅ+ヴ+フ+ゐ+ダ+ゞ+ー+ヴ+ゐ+ヌ+ダ+そ+ゟ+ベ+ゐ+ア+タ+ぐ+ㄍ+ザ+ゐ+ぐ+ア+ネ+ゅ+ゎ+ゅ+ヅ),[ク,ツ,ぶ,ァ,ヮ,ツ,れ,ワ,だ]=[ぽ(+[わ+ぱ]),ぽ(+[わ+わ]),ぽ(+[エ+ま+や+わ]),ぽ(+[ま+オ]),ぽ(+[゛+ま]),ぽ(+[わ+わ]),ぽ(+[ぱ+わ]),ぽ(+[ま+ま+や]),ぽ(+[ぱ+ぱ])],ず(ゅ,ゅ+ウ+ザ+ㄏ+ゎ+ゅ+ウ+ザ+ㄏ+ゎ+ゅ+ヅ+ヅ)([ァ,ベ,フ,ダ,ㄮ,ヴ,ヌ,ア,ダ,ゞ,タ,ザ,ヌ,ダ,ゎ,ヴ,ヅ,ㄞ,ァ,ゞ,ゞ,ゞ,ゞ,ウ,ザ,ゐ,ゞ,ザ,ゞ,ヮ,ゞ,ゆ,ァ,ゞ,ゞ,ゞ,ゞ,ㄮ,ア,ダ,ぷ,ア,ㄏ,ゅ,ゟ,ㄏ,ア,そ,ゎ,ヴ,ツ,ゞ,ザ,ヅ,ァ,て,ァ,タ,ザ,ヌ,ダ,ゎ,れ,ㄍ,ゅ,ㄏ,ㄏ,ア,ゞ,ワ,ア,ゐ,ㄏ,ネ,だ,だ,れ,ヅ,ゞ,ァ][が+ア+ヌ+ダ](ぷ[ぷ+ㄏ+ヌ+ㄮ+ゅ](ま))),ぽ,[ー,ザ,と,ゅ,,ー]+ぽ(ゐ)
```

## options

```js
type options = {
    random: boolean
    custom: string
}
```

## use options

```js
let SakeJS = require("sake-js");
let text = `
function main(t){
    console.log(t)
}
main("hello world!!") 
`;
let res = SakeJS.obfuscate(text, { random: true });
// [閈,㔹,琂,끌,쵔,,뾄,穞,癤,㢻,,,,桖,,ᱶ]="."+{},졠=[],[,ڜ,庬,뎳,ꩱ,ꌂ,䍯,䶓,,,寻,㦉,,,膁]=[!!뾄]+!뾄+뾄.뾄,[,,,,,,,,,ॾ,,,,,賵]=閈[桖+=琂+寻+䶓+穞+ڜ+庬+뾄+穞+琂+ڜ]+졠,[,,,,,,,,瓙,,,,,ዀ,濬,,骶,,,,,,,녓,,,,,,,,,䘜]=[][ꩱ+膁+䍯+䍯]+졠,䞢=[穞+琂+ॾ+穞+ڜ+膁+寻+賵],[粠,,촍,,쌂,,稫,,뮋,,岠,,皆,,ꁽ,,蛌,,䈏]=[+瓙,++瓙,++瓙,++瓙,++瓙,++瓙,++瓙,++瓙,++瓙,++瓙]+졠,α=졠[桖][桖],矾=α(뎳,ڜ+뎳+穞+庬+ڜ+寻+癤+뎳+閈+穞+琂+ॾ+穞+ڜ+膁+寻+賵+ዀ+稫+皆+濬),[鍏,臝,㛒,鷵,罞]=[矾(+[쌂+岠]),矾(+[촍+ꁽ]),矾(+[쌂+쌂]),矾(+[쌂+粠]),矾(+[稫+뮋])],[蹎,,쐦,,,,쌑,,,,濸]=α(ڜ+뎳+穞+庬+ڜ+寻+癤+뎳+䶓+뾄+ꌂ+鍏+뎳)()((졠+졠)[膁+穞+ꌂ+䍯+膁+뾄+䶓]()),䒼=α(뎳,ڜ+뎳+穞+庬+ڜ+寻+癤+ॾ+穞+ڜ+膁+寻+賵+閈+ꩱ+ڜ+琂+㛒+쐦+臝+ꌂ+ڜ+쐦+琂+㦉+뎳+ዀ+뎳+濬),[첓,聫,텵,Ⴖ,崙,聫,닞,批,ｔ]=[䒼(+[뮋+稫]),䒼(+[뮋+뮋]),䒼(+[蛌+촍+䈏+뮋]),䒼(+[촍+粠]),䒼(+[皆+촍]),䒼(+[뮋+뮋]),䒼(+[稫+뮋]),䒼(+[촍+촍+䈏]),䒼(+[稫+稫])],α(뎳,뎳+녓+ꌂ+䍯+ዀ+뎳+녓+ꌂ+䍯+ዀ+뎳+濬+濬)([Ⴖ,ꩱ,庬,寻,뾄,穞,膁,琂,寻,癤,㛒,ꌂ,膁,寻,ዀ,穞,濬,骶,Ⴖ,癤,癤,癤,癤,녓,ꌂ,ڜ,癤,ꌂ,癤,崙,癤,岠,Ⴖ,癤,癤,癤,癤,뾄,琂,寻,䶓,琂,䍯,뎳,閈,䍯,琂,賵,ዀ,穞,聫,癤,ꌂ,濬,Ⴖ,䘜,Ⴖ,㛒,ꌂ,膁,寻,ዀ,닞,臝,뎳,䍯,䍯,琂,癤,批,琂,ڜ,䍯,㦉,ｔ,ｔ,닞,濬,癤,Ⴖ][쵔+琂+膁+寻](䶓[䶓+䍯+膁+뾄+뎳](촍))),䒼,[ॾ,ꌂ,鷵,뎳,,ॾ]+䒼(ڜ)
let res = SakeJS.obfuscate(text, {
  custom: "〆〇〡〢〣〤ㄍㄑ〳ヽ〴丿乀乁乂〸ㆺ〻ミ",
});
// [ㆺ,乂乂,乂乁,乂〸,乂〆,,乂〴,乂〻,乂〢,乂〣,,,,乂,,乂〳]="."+{},〴=[],[,乂ヽ,乂ㄍ,乂〡,乂〤,乂〇,乂ミ,乂丿,,,乂ㄑ,乂乀,,,乂ㆺ]=[!!乂〴]+!乂〴+乂〴.乂〴,[,,,,,,,,,乁乂,,,,,乁乁]=ㆺ[乂+=乂乁+乂ㄑ+乂丿+乂〻+乂ヽ+乂ㄍ+乂〴+乂〻+乂乁+乂ヽ]+〴,[,,,,,,,,〢,,,,,乁〡,乁〴,,乁〸,,,,,,,乁ミ,,,,,,,,,乁〆]=[][乂〤+乂ㆺ+乂ミ+乂ミ]+〴,〆=[乂〻+乂乁+乁乂+乂〻+乂ヽ+乂ㆺ+乂ㄑ+乁乁],[〣,,〳,,ヽ,,ㄍ,,〤,,〇,,ミ,,丿,,ㄑ,,乀]=[+〢,++〢,++〢,++〢,++〢,++〢,++〢,++〢,++〢,++〢]+〴,乁=〴[乂][乂],〸=乁(乂〡,乂ヽ+乂〡+乂〻+乂ㄍ+乂ヽ+乂ㄑ+乂〢+乂〡+ㆺ+乂〻+乂乁+乁乂+乂〻+乂ヽ+乂ㆺ+乂ㄑ+乁乁+乁〡+ㄍ+ミ+乁〴),[乁〳,乁丿,乁ヽ,乁ㄍ,乁〣]=[〸(+[ヽ+〇]),〸(+[〳+丿]),〸(+[ヽ+ヽ]),〸(+[ヽ+〣]),〸(+[ㄍ+〤])],[乁〻,,乁〇,,,,乁〢,,,,乁〤]=乁(乂ヽ+乂〡+乂〻+乂ㄍ+乂ヽ+乂ㄑ+乂〢+乂〡+乂丿+乂〴+乂〇+乁〳+乂〡)()((〴+〴)[乂ㆺ+乂〻+乂〇+乂ミ+乂ㆺ+乂〴+乂丿]()),〻=乁(乂〡,乂ヽ+乂〡+乂〻+乂ㄍ+乂ヽ+乂ㄑ+乂〢+乁乂+乂〻+乂ヽ+乂ㆺ+乂ㄑ+乁乁+ㆺ+乂〤+乂ヽ+乂乁+乁ヽ+乁〇+乁丿+乂〇+乂ヽ+乁〇+乂乁+乂乀+乂〡+乁〡+乂〡+乁〴),[乁ㄑ,乁乀,乁ㆺ,〸乂,〸乁,乁乀,〸〆,〸〡,〸〴]=[〻(+[〤+ㄍ]),〻(+[〤+〤]),〻(+[ㄑ+〳+乀+〤]),〻(+[〳+〣]),〻(+[ミ+〳]),〻(+[〤+〤]),〻(+[ㄍ+〤]),〻(+[〳+〳+乀]),〻(+[ㄍ+ㄍ])],乁(乂〡,乂〡+乁ミ+乂〇+乂ミ+乁〡+乂〡+乁ミ+乂〇+乂ミ+乁〡+乂〡+乁〴+乁〴)([〸乂,乂〤,乂ㄍ,乂ㄑ,乂〴,乂〻,乂ㆺ,乂乁,乂ㄑ,乂〢,乁ヽ,乂〇,乂ㆺ,乂ㄑ,乁〡,乂〻,乁〴,乁〸,〸乂,乂〢,乂〢,乂〢,乂〢,乁ミ,乂〇,乂ヽ,乂〢,乂〇,乂〢,〸乁,乂〢,〇,〸乂,乂〢,乂〢,乂〢,乂〢,乂〴,乂乁,乂ㄑ,乂丿,乂乁,乂ミ,乂〡,ㆺ,乂ミ,乂乁,乁乁,乁〡,乂〻,乁乀,乂〢,乂〇,乁〴,〸乂,乁〆,〸乂,乁ヽ,乂〇,乂ㆺ,乂ㄑ,乁〡,〸〆,乁丿,乂〡,乂ミ,乂ミ,乂乁,乂〢,〸〡,乂乁,乂ヽ,乂ミ,乂乀,〸〴,〸〴,〸〆,乁〴,乂〢,〸乂][乂〆+乂乁+乂ㆺ+乂ㄑ](乂丿[乂丿+乂ミ+乂ㆺ+乂〴+乂〡](〳))),〻,[乁乂,乂〇,乁ㄍ,乂〡,,乁乂]+〻(乂ヽ)
```

## Get more custom [words](https://nuojs.github.io/sake-js/words.html)

https://nuojs.github.io/sake-js/words.html

## Refferance from [aem1k.com](http://aem1k.com/)

